# Doku Rapi Temperatur / Luftfeuchtigkeit

## Verkabelung

| Raspi | Sensor |
|---|---|
| 6 (I2C SDA) | SDA |
| 7 (I2C SCL) | SCL |
| 38 (GND) | GND |
| 36 (3V) | VIN |

## Idee

Auslesen des Sensors und anzeigen der Werte / Verlauf im Browser über HTML

## Umsetzung

- Raspi Pico verkabeln mit Sensor

- Eigende Library fpr BME280 Sensor schreiben (Gab keine)

- Ausgeben der Werte in Konsole

- TCP Sevrer auf Port 80 Starten und bei abfrage den HTML Code der Seite senden.

- /data API endpunkt einbauen, der die Sensordaten in json antwortet.

## Problem

Durch den komplexen aufbau des des PicoSDK TCP examples, konnte die umsetzung der Daten in einer HTML seite nicht erfolgen

Es gab eine 1/100 chance das die Daten in HTML sichtbar waren, da die verbindung zu früh geschlossen wurde und der Browser dann in einen fehler läuft obwohl die daten vorhanden sind.

### Was funktioniert hat

Ausgabe über usb ins terminal (minicom)

![Bild](bilderoderso/setp1.png)

## Erweiterung

### Neue Verkabelung

#### Display

| Pin | Type | Pico |
| --- | ---- | ---- |
| 1 | GND | 38 |
| 2 | VCC | 36 |
| 3 | SCK | 24 |
| 4 | SDA | 25 |
| 5 | RES | 26 |
| 6 | RS | 27 |
| 7 | CS | 29 |
| 8 | VCC (BACKLIGHT) | 36 |

#### SD Leser

| Pin | Type | Pico |
| --- | ---- | ---- |
| 1 | GND | 38 |
| 2 | VCC | 36 |
| 3 | MISO | 16 |
| 4 | SDA/MOSI | 15 |
| 5 | SCK | 14 |
| 6 | CS | 9 |

### HTTP Fehler

HTTP Fehler wurde behoben. Die Connection wird nun richtig geschlossen. Dadurch gibt es auch die möglichkeit die Daten in Charts anzuzeigen (Ein Datensatz alle 10 Sekunden)

![Bild](bilderoderso/site.png)

### Display Erweiterung

Zusätzlich gibe es ein Display, welches Live Daten, IP, Durchschnittliche Date der letzten 1000 Datensätze. Zusätlich gibt es einen BLUE Screen, wenn ein fehler auftritt mit eingebauter fehlermeldung und automatischem reboot nach 10 Sekunden.

Der fehlerbildschirm macht auch die WIFI Error LED auf gpio 15 überflüssig.

Des weiteren gibt es noch einen 16 Stelligen Hexadezimal fehlerzehler für den TCP (HTTP) Server, als debug info durch die man erkennt, wenn sich der server villeicht komplett aufgehangen hat. 16 Stellig Hexadecimal liegt daran, das der fehlerwert in einer 64 bit zahl gespeichert wird

### Input Pins

Zusätlich gibt es noch die möglich keit, mithilfe von Pin14, wenn man strom drauf gibt, ohne Wifi zu booten, was nütulich ist für lokale tests, ohne dauernd daraud zu warten das der Pi Pico sich verbindet.

Auf Pin13 Gibt es die möglichkeit einen reboot auszulösen, welchen man z.B nutzen kann, um einmal alles zurüclzusetzen oder in den BOOTSEL (Flash) Mode zu booten

### SD Karte

SD Karten erweiterung funktioniert noch nicht.

Die Idee dahinter ist, daten auf der SD Karte zu speichern und dadurch eine größere Zeitspane auf der Seite anzeigen zu können, ohne das die Daten bei einem Reboot verloren gehen und ohne Limitation durch die größe des RAM Chips

### Final

![Bild](bilderoderso/over-time.png)
